import graphlab as gl
import logging
from enum import Enum
from logging.handlers import RotatingFileHandler

AWS_ACCESS_KEY_ID = 'AKIAI5G63C53MARBWQEQ'  # Need to setup
AWS_SECRET_ACCESS_KEY = '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'  # Need to setup
gl.aws.set_credentials(AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY)
TMP_DIR = '/data/fire/tmp'#'/data/tmp'
gl.set_runtime_config('GRAPHLAB_CACHE_FILE_LOCATIONS', TMP_DIR)
gl.set_runtime_config('GRAPHLAB_DEFAULT_NUM_PYLAMBDA_WORKERS', 32)
gl.set_runtime_config('GRAPHLAB_DEFAULT_NUM_GRAPH_LAMBDA_WORKERS', 32)


SFRAMES_BASE_DIR = "/data/fire/sframes/papers"
DATASETS_BASE_DIR = "/data/fire/sframes/papers"
SFRAMES_BASE_DIR = "/data/fire/sframes/papers"
S3_BASE_BUCKET = "s3://mf-networks/sframes/papers"
PAPERS_ALL_FEATURES = "%s/PapersAllFeatures.sframe" % SFRAMES_BASE_DIR

FIELDS_OF_STUDY_TXT = "%s/FieldsOfStudy.txt" % DATASETS_BASE_DIR
FIELDS_OF_STUDY_SFRAME = "%s/FieldsOfStudy.sframe" % SFRAMES_BASE_DIR
FIELDS_OF_STUDY_S3_SFRAME = "%s/FieldsOfStudy.sframe" % S3_BASE_BUCKET

FIELDS_OF_STUDY_HIERARCHY_TXT = "%s/FieldOfStudyHierarchy.txt" % DATASETS_BASE_DIR
FIELDS_OF_STUDY_HIERARCHY_SFRAME = "%s/FieldOfStudyHierarchy.sframe" % SFRAMES_BASE_DIR
FIELDS_OF_STUDY_HIERARCHY_S3_SFRAME = "%s/FieldOfStudyHierarchy.sframe" % S3_BASE_BUCKET

PAPERS_TXT = "%s/Papers.txt" % DATASETS_BASE_DIR
PAPERS_SFRAME = "%s/Papers.sframe" % SFRAMES_BASE_DIR
PAPERS_S3_SFRAME = "%s/Papers.sframe" % S3_BASE_BUCKET


EXTENDED_PAPERS_SFRAME = "%s/ExtendedPapers.sframe" % SFRAMES_BASE_DIR
EXTENDED_PAPERS_S3_SFRAME = "%s/ExtendedPapers.sframe" % S3_BASE_BUCKET

CLEAN_EXTENDED_PAPERS_SFRAME = "%s/CleanExtendedPapers.sframe" % SFRAMES_BASE_DIR
CLEAN_EXTENDED_PAPERS_S3_SFRAME = "%s/CleanExtendedPapers.sframe" % S3_BASE_BUCKET


FEATURES_EXTENDED_PAPERS_SFRAME = "%s/FeaturesCleanExtendedPapers.sframe" % SFRAMES_BASE_DIR
FEATURES_EXTENDED_PAPERS_S3_SFRAME = "%s/FeaturesCleanExtendedPapers.sframe" % S3_BASE_BUCKET

PAPER_AUTHOR_AFFILIATIONS_TXT = "%s/PaperAuthorAffiliations.txt" % DATASETS_BASE_DIR
PAPER_AUTHOR_AFFILIATIONS_SFRAME = "%s/PaperAuthorAffiliations.sframe" % SFRAMES_BASE_DIR
PAPER_AUTHOR_AFFILIATIONS_S3_SFRAME = "%s/PaperAuthorAffiliations.sframe" % S3_BASE_BUCKET


CONFRENCES_TXT = "%s/Confrences.txt" % DATASETS_BASE_DIR
CONFRENCES_SFRAME = "%s/Confrences.sframe" % SFRAMES_BASE_DIR
CONFRENCES_S3_SFRAME = "%s/Confrences.sframe" % S3_BASE_BUCKET


JOURNALS_TXT = "%s/Journals.txt" % DATASETS_BASE_DIR
JOURNALS_SFRAME = "%s/Journals.sframe" % SFRAMES_BASE_DIR
JOURNALS_S3_SFRAME = "%s/Journals.sframe" % S3_BASE_BUCKET

PAPER_KEYWORDS_TXT = "%s/PaperKeywords.txt" % DATASETS_BASE_DIR
PAPER_KEYWORDS_SFRAME = "%s/PaperKeywords.sframe" % SFRAMES_BASE_DIR
PAPER_KEYWORDS_S3_SFRAME = "%s/PaperKeywords.sframe" % S3_BASE_BUCKET

PAPER_REFERENCES_TXT = "%s/PaperReferences.txt" % DATASETS_BASE_DIR
PAPER_REFERENCES_SFRAME = "%s/PaperReferences.sframe" % SFRAMES_BASE_DIR
PAPER_REFERENCES_S3_SFRAME = "%s/PaperReferences.sframe" % S3_BASE_BUCKET

JOURNALS_PAPERS_SFRAMES_DIR = "/data/fire/sframes/journals"
CONFERENCES_PAPERS_SFRAMES_DIR = "/data/fire/sframes/conferences"

CO_AUTHORSHIP_LINK_SFRAME = "%s/co_authors_links.sframe" % SFRAMES_BASE_DIR
CO_AUTHORSHIP_LINK_S3_SFRAME = "%s/co_authors_links.sframe" % S3_BASE_BUCKET

L3_FIELD_PAPERS_LIST_SFRAME = "%s/L3DomainPapersLists.sframe" % SFRAMES_BASE_DIR
L3_FIELD_PAPERS_LIST_S3_SFRAME = "%s/L3DomainPapersLists.sframe" % S3_BASE_BUCKET

AUTHORS_ACADEMIC_BIRTH_YEAR = "%s/AuthorsAcademicBirthYear.sframe" % SFRAMES_BASE_DIR
JOURNAL_AUTHORS_ACADEMIC_BIRTHYEAR_PKL = "%s/journal_authors_academic_birthyear.pkl" % SFRAMES_BASE_DIR
CONFERENCE_AUTHORS_ACADEMIC_BIRTHYEAR_PKL = "%s/conference_authors_academic_birthyear.pkl" % SFRAMES_BASE_DIR

logFormatter = logging.Formatter("%(asctime)s [%(threadName)-12.12s] [%(levelname)-5.5s]  %(message)s")
logger = logging.getLogger()
fileHandler = RotatingFileHandler(TMP_DIR + '/complex_network.log', mode='a', maxBytes=5*1024*1024,
                                 backupCount=2, encoding=None, delay=0)
fileHandler.setFormatter(logFormatter)
logger.addHandler(fileHandler)
consoleHandler = logging.StreamHandler()
consoleHandler.setFormatter(logFormatter)
logger.addHandler(consoleHandler)
logger.setLevel(logging.DEBUG)



class VenueType(Enum):
    journal = 1
    conference = 2